﻿import es, gamethread, playerlib, langlib, os

info = es.AddonInfo()
info.name = "Radio Spam Block" 
info.version = "1.1"
info.author = "Tooshkan4uk" 
info.url = "http:/addons.eventscripts.com/addons/view/radiospamblock"

es.ServerVar('es_rsb_version', info.version, '').makepublic()

text = langlib.Strings("cstrike/addons/eventscripts/radiospamblock/language.ini")
filepath = es.getAddonPath("radiospamblock") + '/config.cfg'

if not os.path.isfile(filepath):
    writeconfig = open(filepath, "w")
    writeconfig.write('// This file was auto-generated by EventScripts (v%s)\n'%es.ServerVar("eventscripts_ver"))
    writeconfig.write('// ConVars for plugin "radiospamblock.pyc"\n\n\n')
    writeconfig.write('// 0 = disabled, 1 = enabled Radio Spam Block functionality\n')
    writeconfig.write('// -\n')
    writeconfig.write('// Default: "1"\n')
    writeconfig.write('es_radio_spam_block 1\n')
    writeconfig.write('// Time in seconds between radio messages\n')
    writeconfig.write('// -\n')
    writeconfig.write('// Default: "5"\n')
    writeconfig.write('es_radio_spam_block_time 5\n')
    writeconfig.write('// 0 = disabled, 1 = block all radio messages\n')
    writeconfig.write('// -\n')
    writeconfig.write('// Default: "0"\n')
    writeconfig.write('es_radio_spam_block_all 0\n')
    writeconfig.write('// 0 = disabled, 1 = show a chat message to the player when his radio spam blocked\n')
    writeconfig.write('// -\n')
    writeconfig.write('// Default: "1"\n')
    writeconfig.write('es_radio_spam_block_notify 1')
    writeconfig.close()


enabled = es.ServerVar("es_radio_spam_block")
rtime = es.ServerVar("es_radio_spam_block_time")
blockall = es.ServerVar("es_radio_spam_block_all")
message = es.ServerVar("es_radio_spam_block_notify")

data = {}

radio = ['coverme', 
'takepoint', 
'holdpos',
'regroup',
'followme', 
'takingfire', 
'go', 
'fallback', 
'sticktog', 
'getinpos', 
'stormfront', 
'report', 
'roger', 
'enemyspot', 
'needbackup', 
'sectorclear', 
'inposition',
'reportingin', 
'getout', 
'negative', 
'enemydown']

def load():
    global data
    data.clear()
    es.server.queuecmd("es_xmexec ../addons/eventscripts/radiospamblock/config.cfg")
    es.addons.registerClientCommandFilter(radioblock)
    for userid in es.getUseridList():
        data[userid] = {}
        data[userid]['time'] = 0

def unload():
    es.addons.unregisterClientCommandFilter(radioblock) 

def radioblock(userid, args):
    global data
    player = playerlib.getPlayer(userid)
    tokens = {}
    if args[0].lower() in radio:
        if enabled:
            if blockall:
                if message:
                    es.tell(userid, "#multi", text("disabled", tokens, player.get("lang")))
                return False
            else:            
                if data[userid]['time'] > 1:
                    tokens['time'] = data[userid]['time']
                    if message:
                        es.tell(userid, "#multi", text("wait x seconds", tokens, player.get("lang")))
                    return False
                if data[userid]['time'] == 1:
                    if message:
                        es.tell(userid, "#multi", text("wait 1 second", tokens, player.get("lang")))
                    return False
                if data[userid]['time'] == 0:
                    if data.has_key(userid):
                        data[userid]['time'] = rtime
                        gamethread.delayed(1, timer, userid)
                        return True
    return True


def timer(userid):
    global data
    data[userid]['time'] -= 1
    if data[userid]['time'] > 0:
        gamethread.delayed(1, timer, userid)

def player_team(event_var):
    global data
    userid = int(event_var['userid'])
    if not data.has_key(userid):
        data[userid] = {}
        data[userid]['time'] = 0
    
    
    
